//
// cocos2d Hello World example
// http://www.cocos2d-iphone.org
//

// Import the interfaces
#import "HelloWorldScene.h"

// HelloWorld implementation
@implementation HelloWorld


+(id) scene
{
	// 'scene' is an autorelease object.
	Scene *scene = [Scene node];
	
	// 'layer' is an autorelease object.
	HelloWorld *layer = [HelloWorld node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

// on "init" you need to initialize your instance
-(id) init
{
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super" return value
	if( (self=[super init] )) {
		
		// isTouchEnabled is an property of Layer (the super class).
		// When it is YES, then the touches will be enabled
		self.isTouchEnabled = YES;
		
		
		// create and initialize a Label
		Label* label = [Label labelWithString:@"Hello World" fontName:@"Marker Felt" fontSize:64];

		// ask director the the window size
		CGSize size = [[Director sharedDirector] winSize];
	
		// position the label on the center of the screen
		label.position =  ccp( size.width /2 , size.height/2 );
		
		// add the label as a child to this Layer
		[self addChild: label];
		
		mySprite = [Sprite spriteWithFile:@"Icon.png"];
		mySprite.position = ccp( mySprite.texture.pixelsWide/2, 100);
		
		// z is the z-order. Greater values means on top of lower values.
		// default z value is 0.
		// So the sprite will be on top of the label.
		[self addChild:mySprite z:1];
		
	}
	return self;
}

- (BOOL)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
	UITouch *touch = [touches anyObject];
	
	if( touch ) {
		CGPoint location = [touch locationInView: [touch view]];
		
		// IMPORTANT:
		// The touches are always in "portrait" coordinates. You need to convert them to your current orientation
		CGPoint convertedPoint = [[Director sharedDirector] convertToGL:location];
		
		NSLog(@"You pressed at location: (%f, %f)%n", convertedPoint.x, convertedPoint.y);
		//Sprite *sprite = (Sprite*)[self getChildByTag:kTagSprite];
		
		// ask director the the window size
		CGSize size = [[Director sharedDirector] winSize];
				
		// we stop the all running actions
		[mySprite stopAllActions];
		//mySprite.position = ccp(mySprite.texture.pixelsWide/2, 100);
		mySprite.position = convertedPoint;
		mySprite.rotation = 0;
		
		
		
		// create a RotateBy action.
		// "By" means relative. "To" means absolute.
		id rotateAction = [RotateBy actionWithDuration:4 angle:180*10];
		
		// create a JumpBy action.
		
		id jumpAction = [JumpBy actionWithDuration:4 
										  position:ccp(size.width - mySprite.texture.pixelsWide - convertedPoint.x,0) 
											height:100 jumps:4];
		
		// spawn is an action that executes 2 or more actions at the same time
		id fordward = [Spawn actions:rotateAction, jumpAction, nil];
		
		// almost all actions supports the "reverse" method. 
		// It will create a new actions that is the reversed action.
		id backwards = [fordward reverse];
		
		// Sequence is an action that executes one action after another one
		id sequence = [Sequence actions: fordward, backwards, nil];
		
		// Finally, you can repeat an action as many times as you want.
		// You can repeat an action forever using the "RepeatForEver" action.
		id repeatAction = [Repeat actionWithAction:sequence times:2];
	
		// Tell the sprite to execute the actions.
		// The action will be execute once this Layer appears on the screen (not before).
		[mySprite runAction:repeatAction];
		
		// no other handlers will receive this event
		return kEventHandled;
	}
	
	// we ignore the event. Other receivers will receive this event.
	return kEventIgnored;
}

// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
	// in case you have something to dealloc, do it in this method
	// in this particular example nothing needs to be released.
	// cocos2d will automatically release all the children (Label)
	
	// don't forget to call "super dealloc"
	[super dealloc];
}
@end
